# 贡献指南

> 请您勇敢地去翻译和改进翻译。虽然我们追求卓越，但我们并不要求您做到十全十美，因此请不要担心因为翻译上犯错——在大部分情况下，我们的服务器已经记录所有的翻译，因此您不必担心会因为您的失误遭到无法挽回的破坏。（改编自维基百科）

可能有用的链接：

+ [英文官网](https://scikit-learn.org)
+ [中文翻译](https://sklearn.apachecn.org)

负责人：

* [@loopyme](https://github.com/loopyme)：3322728009
* [飞龙](https://github.com/wizardforcel)：562826179
* [片刻](https://github.com/jiangzhonglian)：529815144

## 章节列表

*   [安装 scikit-learn](docs/0.21.3/62.md)
*   用户指南
    *   [1. 监督学习](docs/0.21.3/1.md)
        * [1.1. 广义线性模型](docs/0.21.3/2.md)
        * [1.2. 线性和二次判别分析](docs/0.21.3/3.md)
        * [1.3. 内核岭回归](docs/0.21.3/4.md)
        * [1.4. 支持向量机](docs/0.21.3/5.md)
        * [1.5. 随机梯度下降](docs/0.21.3/6.md)
        * [1.6. 最近邻](docs/0.21.3/7.md)
        * [1.7. 高斯过程](docs/0.21.3/8.md)
        * [1.8. 交叉分解](docs/0.21.3/9.md)
        * [1.9. 朴素贝叶斯](docs/0.21.3/10.md)
        * [1.10. 决策树](docs/0.21.3/11.md)
        * [1.11. 集成方法](docs/0.21.3/12.md)
        * [1.12. 多类和多标签算法](docs/0.21.3/13.md)
        * [1.13. 特征选择](docs/0.21.3/14.md)
        * [1.14. 半监督学习](docs/0.21.3/15.md)
        * [1.15. 等式回归](docs/0.21.3/16.md)
        * [1.16. 概率校准](docs/0.21.3/17.md)
        * [1.17. 神经网络模型（有监督）](docs/0.21.3/18.md)
    *   [2. 无监督学习](docs/0.21.3/19.md)
        * [2.1. 高斯混合模型](docs/0.21.3/20.md)
        * [2.2. 流形学习](docs/0.21.3/21.md)
        * [2.3. 聚类](docs/0.21.3/22.md)
        * [2.4. 双聚类](docs/0.21.3/23.md)
        * [2.5. 分解成分中的信号（矩阵分解问题）](docs/0.21.3/24.md)
        * [2.6. 协方差估计](docs/0.21.3/25.md)
        * [2.7. 新奇和异常值检测](docs/0.21.3/26.md)
        * [2.8. 密度估计](docs/0.21.3/27.md)
        * [2.9. 神经网络模型（无监督）](docs/0.21.3/28.md)
    * [3. 模型选择和评估](docs/0.21.3/29.md)
        * [3.1. 交叉验证：评估估算器的表现](docs/0.21.3/30.md)
        * [3.2. 调整估计器的超参数](docs/0.21.3/31.md)
        * [3.3. 模型评估: 量化预测的质量](docs/0.21.3/32.md)
        * [3.4. 模型持久化](docs/0.21.3/33.md)
        * [3.5. 验证曲线: 绘制分数以评估模型](docs/0.21.3/34.md)
    * [4.  检验](docs/0.21.3/35.md)
        * [4.1. 部分依赖图](docs/0.21.3/36.md)
    * [5. 数据集转换](docs/0.21.3/37.md)
        * [5.1. Pipeline（管道）和 FeatureUnion（特征联合）: 合并的评估器](docs/0.21.3/38.md)
        * [5.2. 特征提取](docs/0.21.3/39.md)
        * [5.3 预处理数据](docs/0.21.3/40.md)
        * [5.4 缺失值插补](docs/0.21.3/41.md)
        * [5.5. 无监督降维](docs/0.21.3/42.md)
        * [5.6. 随机投影](docs/0.21.3/43.md)
        * [5.7. 内核近似](docs/0.21.3/44.md)
        * [5.8. 成对的矩阵, 类别和核函数](docs/0.21.3/45.md)
        * [5.9. 预测目标 (`y`) 的转换](docs/0.21.3/46.md)
    * [6. 数据集加载工具](docs/0.21.3/47.md)
        * [6.1. 通用数据集 API](docs/0.21.3/47.md)
        * [6.2. 玩具数据集](docs/0.21.3/47.md)
        * [6.3 真实世界中的数据集](docs/0.21.3/47.md)
        * [6.4. 样本生成器](docs/0.21.3/47.md)
        * [6.5. 加载其他数据集](docs/0.21.3/47.md)
    * [7. 使用scikit-learn计算](docs/0.21.3/48.md)
        * [7.1. 大规模计算的策略: 更大量的数据](docs/0.21.3/48.md)
        * [7.2. 计算性能](docs/0.21.3/48.md)
        * [7.3. 并行性、资源管理和配置](docs/0.21.3/48.md)
*   [教程](docs/0.21.3/50.md)
    *   [使用 scikit-learn 介绍机器学习](docs/0.21.3/51.md)
    *   [关于科学数据处理的统计学习教程](docs/0.21.3/52.md)
        *   [机器学习: scikit-learn 中的设置以及预估对象](docs/0.21.3/53.md)
        *   [监督学习：从高维观察预测输出变量](docs/0.21.3/54.md)
        *   [模型选择：选择估计量及其参数](docs/0.21.3/55.md)
        *   [无监督学习: 寻求数据表示](docs/0.21.3/56.md)
        *   [把它们放在一起](docs/0.21.3/57.md)
        *   [寻求帮助](docs/0.21.3/58.md)
    *   [处理文本数据](docs/0.21.3/59.md)
    *   [选择正确的评估器(estimator.md)](docs/0.21.3/60.md)
    *   [外部资源，视频和谈话](docs/0.21.3/61.md)
*   [API 参考](https://scikit-learn.org/stable/modules/classes.html)
*   [常见问题](docs/0.21.3/63.md)
*   [时光轴](docs/0.21.3/64.md)

## 流程

### 一、认领

首先查看[整体进度](https://github.com/apachecn/sklearn-doc-zh/issues/352)，确认没有人认领了你想认领的章节。
 
然后回复 ISSUE，注明“章节 + QQ 号”（一定要留 QQ）。

### 二、校对

需要校对：

1.  语法
2.  术语使用
3.  文档格式

如果觉得现有翻译不好，重新翻译也是可以的。

### 三、提交

**提交的时候不要改动文件名称，即使它跟章节标题不一样也不要改，因为文件名和原文的链接是对应的！！！**

+   `fork` Github 项目
+   将译文放在`docs/1.0`文件夹下
+   `push`
+   `pull request`

请见 [Github 入门指南](https://github.com/apachecn/kaggle/blob/master/docs/GitHub)。
