# scikit-learn (sklearn) 官方文档中文版

scikit-learn 是基于 Python 语言的机器学习工具

1. 简单高效的数据挖掘和数据分析工具
2. 可供大家在各种环境中重复使用
3. 建立在 NumPy ，SciPy 和 matplotlib 上
4. 开源，可商业使用 - BSD许可证


## 维护地址

+   [Github](https://github.com/apachecn/scikit-learn-doc-zh/)
+   [在线阅读](http://sklearn.apachecn.org)
+   [EPUB 格式](https://github.com/apachecn/scikit-learn-doc-zh/raw/dl/scikit-learn%200.19%20%E4%B8%AD%E6%96%87%E6%96%87%E6%A1%A3.epub)

## 目录

*   [安装 scikit-learn](62.md)
*   用户指南
    *   [1. 监督学习](1.md)
        * [1.1. 广义线性模型](2.md)
        * [1.2. 线性和二次判别分析](3.md)
        * [1.3. 内核岭回归](4.md)
        * [1.4. 支持向量机](5.md)
        * [1.5. 随机梯度下降](6.md)
        * [1.6. 最近邻](7.md)
        * [1.7. 高斯过程](8.md)
        * [1.8. 交叉分解](9.md)
        * [1.9. 朴素贝叶斯](10.md)
        * [1.10. 决策树](11.md)
        * [1.11. 集成方法](12.md)
        * [1.12. 多类和多标签算法](13.md)
        * [1.13. 特征选择](14.md)
        * [1.14. 半监督学习](15.md)
        * [1.15. 等式回归](16.md)
        * [1.16. 概率校准](17.md)
        * [1.17. 神经网络模型（有监督）](18.md)
    *   [2. 无监督学习](19.md)
        * [2.1. 高斯混合模型](20.md)
        * [2.2. 流形学习](21.md)
        * [2.3. 聚类](22.md)
        * [2.4. 双聚类](23.md)
        * [2.5. 分解成分中的信号（矩阵分解问题）](24.md)
        * [2.6. 协方差估计](25.md)
        * [2.7. 新奇和异常值检测](26.md)
        * [2.8. 密度估计](27.md)
        * [2.9. 神经网络模型（无监督）](28.md)
    * [3. 模型选择和评估](29.md)
        * [3.1. 交叉验证：评估估算器的表现](30.md)
        * [3.2. 调整估计器的超参数](31.md)
        * [3.3. 模型评估: 量化预测的质量](32.md)
        * [3.4. 模型持久化](33.md)
        * [3.5. 验证曲线: 绘制分数以评估模型](34.md)
    * [4.  检验](35.md)
        * [4.1. 部分依赖图](36.md)
    * [5. 数据集转换](37.md)
        * [5.1. Pipeline（管道）和 FeatureUnion（特征联合）: 合并的评估器](38.md)
        * [5.2. 特征提取](39.md)
        * [5.3 预处理数据](40.md)
        * [5.4 缺失值插补](41.md)
        * [5.5. 无监督降维](42.md)
        * [5.6. 随机投影](43.md)
        * [5.7. 内核近似](44.md)
        * [5.8. 成对的矩阵, 类别和核函数](45.md)
        * [5.9. 预测目标 (`y`) 的转换](46.md)
    * [6. 数据集加载工具](47.md)
        * [6.1. 通用数据集 API](47.md)
        * [6.2. 玩具数据集](47.md)
        * [6.3 真实世界中的数据集](47.md)
        * [6.4. 样本生成器](47.md)
        * [6.5. 加载其他数据集](47.md)
    * [7. 使用scikit-learn计算](48.md)
        * [7.1. 大规模计算的策略: 更大量的数据](48.md)
        * [7.2. 计算性能](48.md)
        * [7.3. 并行性、资源管理和配置](48.md)
*   [教程](50.md)
    *   [使用 scikit-learn 介绍机器学习](51.md)
    *   [关于科学数据处理的统计学习教程](52.md)
        *   [机器学习: scikit-learn 中的设置以及预估对象](53.md)
        *   [监督学习：从高维观察预测输出变量](54.md)
        *   [模型选择：选择估计量及其参数](55.md)
        *   [无监督学习: 寻求数据表示](56.md)
        *   [把它们放在一起](57.md)
        *   [寻求帮助](58.md)
    *   [处理文本数据](59.md)
    *   [选择正确的评估器(estimator.md)](60.md)
    *   [外部资源，视频和谈话](61.md)
*   [API 参考](https://scikit-learn.org/stable/modules/classes.html)
*   [常见问题](63.md)
*   [时光轴](64.md)

## 贡献指南

项目当前处于校对阶段，请查看[贡献指南](CONTRIBUTING.md)，并在[整体进度](https://github.com/apachecn/sklearn-doc-zh/issues/352)中领取任务。

> 请您勇敢地去翻译和改进翻译。虽然我们追求卓越，但我们并不要求您做到十全十美，因此请不要担心因为翻译上犯错——在大部分情况下，我们的服务器已经记录所有的翻译，因此您不必担心会因为您的失误遭到无法挽回的破坏。（改编自维基百科）

## 项目负责人

格式: GitHub + QQ

* [@mahaoyang](https://github.com/mahaoyang)：992635910
* [@loopyme](https://github.com/loopyme)：3322728009
* [飞龙](https://github.com/wizardforcel)：562826179
* [片刻](https://github.com/jiangzhonglian)：529815144

-- 负责人要求: (欢迎一起为 `sklearn 中文版本` 做贡献)

* 热爱开源，喜欢装逼
* 长期使用 sklearn(至少0.5年) + 提交Pull Requests>=3
* 能够有时间及时优化页面 bug 和用户 issues
* 试用期: 2个月
* 欢迎联系: [片刻](https://github.com/jiangzhonglian) 529815144

## **项目协议**

以各项目协议为准。

ApacheCN 账号下没有协议的项目，一律视为 [CC BY-NC-SA 4.0](https://creativecommons.org/licenses/by-nc-sa/4.0/deed.zh)。

## 建议反馈

* 在我们的 [apachecn/pytorch-doc-zh](https://github.com/apachecn/sklearn-doc-zh) github 上提 issue.
* 发邮件到 Email: `apachecn@163.com`.
* 在我们的 [QQ群-搜索: 交流方式](https://github.com/apachecn/home) 中联系群主/管理员即可.

## 赞助我们

<img src="http://data.apachecn.org/img/about/donate.jpg" alt="微信&支付宝" />
